'
$DEFINE NO_RQ_LIB_IN_PACKAGE
'
SetConsoleTitle (Application.ExeName & "   102"
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
$INCLUDE "QInputBox.Inc"
Dim myInput As QInputBox
'
' Hash Function                        see  WARNING.TXT
$Include "Hash32Bit.Inc"
' Count Different Chars Between two trings of same size
$Include "CountDiffBytes.Inc"
'
' Grab a File over the Internet : The original RQ LIbs and DLLs 
$Include "GETFILEHTTP.Inc"
'
Declare Function CheckKnownLib (iHash As Integer) As Long
Declare Function GetLibDir () As String
Declare Sub ScanDirForLibs
'
$IFDEF NO_RQ_LIBS_IN_PACKAGE
' =============================================================================
' Check If RQ Libs are in this directory
DefStr ThisDir = Command$(0) - Application.ExeName 
If (FileExists (ThisDir & "Rapidq2c.lib") = 0 Or FileExists (ThisDir & "Rapidq32.dll") = 0) Then
    If MessageDlg("I WILL DOWNLOAD \"rqlibs.Zip\" And \"rqdlls.zip\"\n" _
                                      & "from http://www.basicguru.com/rapidq", mtConfirmation, _
                                      mbCANCEL Or mbOK, 0) = IdOK Then
        Print "WAIT: Trying to DownLoad http://www.basicguru.com/rapidq/rqlibs.zip"
        If GetFileHTTP ("http://www.basicguru.com/rapidq/rqlibs.zip", ThisDir & "rqlibsORG.zip") Then
            ShowMessage ("CANT DOWNLOAD:\n     http://www.basicguru.com/rapidq/rqlibs.zip" _
                                       & "\n     PROGRAM WILL NOT WORK CORRECTLY ... TRY LATER" _
                                       & "\n     OR FIND THE ORIGINAL \"RQLIBS.ZIP\" ELSEWHERE" _
                                       & "\n\n     I WILL TERMINATE")
            Application.Terminate
        Else
            Print "OK DOWNLOADED:\n     http://www.basicguru.com/rapidq/rqlibs.zip\n     TO:\n     " _
                                       & ThisDir & "rqlibsOrg.zip"
        End If    
        Print "WAIT: Trying to DownLoad http://www.basicguru.com/rapidq/rqdlls.zip"
        If GetFileHTTP ("http://www.basicguru.com/rapidq/rqdlls.zip", ThisDir & "rqdllsORG.zip") Then
            ShowMessage ("CANT DOWNLOAD:\n     http://www.basicguru.com/rapidq/rqdlls.zip" _
                                       & "\n     PROGRAM WILL NOT WORK CORRECTLY ... TRY LATER" _
                                       & "\n     OR FIND THE ORIGINAL \"RQDLLS.ZIP\" ELSEWHERE" _
                                       & "\n\n     I WILL TERMINATE")
            Application.Terminate
        Else
            Print "OK DOWNLOADED:\n     http://www.basicguru.com/rapidq/rqlibs.zip\n     TO:\n     " _
                                       & ThisDir & "rqlibsOrg.zip"
        End If
        DefStr sMsg = ("\nNOW YOU HAVE TO UNZIP THESE TWO FILES: \n     IN  \"" & ThisDir & "\"" _
                                       & "\n     BEFORE TO GO ON")
        ShowMessage (sMsg)
        '
        While (FileExists (ThisDir & "Rapidq2c.lib") = 0 Or FileExists (ThisDir & "Rapidq32.dll") = 0)
            ShowMessage ("RQLIBS and RQDLLS ARE NOT PRESENT IN \"" & ThisDir & "\"\n    UNZIP \"rqlibs.zip\" and \"rqdlls.zip\"")
        Wend        
        '
        If MessageDlg("I WILL UN_UPX THE \"*.Lib\" and \"*.Dll\"\nIn \"" & ThisDir & "\"", _
                    mtConfirmation, mbCancel OR mbOK, 0) = IdOK Then
            DefInt iShell
            iShell = Shell ("upx -d " & ThisDir & "*.lib", 5)
            iShell = Shell ("upx -d " & ThisDir & "*.dll", 5)   
        Else
            ShowMessage ("THIS SOFTWARE REQUIRES THESE FILES UN_UPX\n\nI TERMINATE")
            Application.Terminate
        End IF
    Else
        ShowMessage ("THIS SOFTWARE REQUIRES THESE FILES\n\nI TERMINATE")
        Application.Terminate
    End If
Else
    Print "RapidQ Libs and Dlls are Present !"
End If
$ENDIF
' =============================================================================
'
' List of RQ Libs FileNames
Dim slLibNames As QStringList
slLibNames.Additems "RapidQ2.Lib", "RapidQ2c.Lib", "RapidQ3.Lib", "RapidQ3c.Lib", "RapidQ4.Lib", "RapidQ4c.Lib", _
        "RapidQcc.Lib", "RapidQ32.Lib", "RapidQCC.Dll", "RapidQ32.Dll"
'
' List of Known Group Libraries
Dim slKnownLibs As QStringList  ' Format .item(N) = Hex$(HashValue) & "*" & LibName & "*" & LibGroupName
'
' List of text output to save to file
Dim slText As QStringList
' INITIALISATION
' --------------
DefStr sGroupName = "", sNewGroupName
' Get slKnownLibs from file
If FileExists ("KnownLibs.Slst") <> 0 Then
    slKnownLibs.LoadFromFile ("KnownLibs.Slst")
Else      ' create empty if dont exist
    slKnownLibs.Clear
    slKnownLibs.SaveToFile ("KnownLibs.Slst")
End If
DefStr sInitDir = "C:\\Rapid-Q\\Libs"
DefInt flagChangeInitDir = 1
' RQ Libs Directory
' -----------------
DefStr sLibDir
$Include "QBrowseDialog.Inc"
Dim myBrowserDir AS QBrowseDialog
'
' Scan Directory for Known or new Libraries
' -----------------------------------------
Do
    sLibDir = GetLibDir
    If sLibDir <> "" Then
        Print ("\n___NEW DIR___: " & sLibDir)
        slText.AddItems ("\n___NEW DIR___: " & sLibDir)
        ScanDirForLibs
        slKnownLibs.SaveToFile ("KnownLibs.Slst")
    End If
    If MessageDlg("WOULD YOU LIKE TO SCAN ANOTHER DIRECTORY ?", mtInformation, mbOK OR mbCancel, 0) = IdCancel Then
        Exit Do
    End If
    sNewGroupName = ""
Loop Until (1 + 1 = 3)  ' :)
' Save the Output Screen
DefStr sSavedScreen = "TextOut_" & ((Date$ - "-") -"/") & "_" & (Time$ - ":") & ".Txt"
Print "\nCONTENT OF THIS SCREEN SAVED AS  \"";sSavedScreen;"\""
slText.SaveToFile (sSavedScreen)
ShowMessage (slText.Text)
'
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n                    CR to QUIT", sExit
Application.Terminate
End
' ---- SUBs and FUNCTIONs -------------------------------------
Function GetLibDir () As String
    DefStr sTmp
    With myBrowserDir
        .Caption = "RapidQ DLL/LIB Version Tool"
        .Title = "SELECT A DIRECTORY TO SCAN FOR RQ LIBRARIES"
        .InitialDir = sInitDir
        If .Execute = True Then
            sTmp = .Directory
            Result = sTmp & "\\"
        Else
            ShowMessage ("  *** ERROR : CANT EXECUTE QBROWSEDIALOG")
            Result = ""
        End If
    End With
    If (flagChangeInitDir = 1 and Ucase$(sTmp) <> Ucase$(sInitDir)) Then
        If Tally(sTmp, "\\") > 1 Then sInitDir = Left$(sTmp, RInstr(sTmp, "\\") - 1)
    End If
    flagChangeInitDir = 0
End Function
' -------------------------------------------------------------
Function CheckKnownLib (iHash As Integer) As Long
    DefInt N
    DefStr sHash = Hex$(iHash)
    For N = 0 To slKnownLibs.ItemCount - 1
        If sHash = Field$(slKnownLibs.Item(N), "*", 1) Then
            sGroupName = Field$(slKnownLibs.Item(N), "*", 3)
            Result = N
            Exit function
        End If
    Next N
    If sNewGroupName = "" Then
        sNewGroupName = myInput.Show ("LIBRARY NOT KNOWN YET\n\nENTER A GROUP NAME FOR THESES LIBS", "RQ KNOWN LIBS GROUPS",      "IE : GROUP NAME + YOUR RQ NAME")
    End If
    Result = -1
End Function
' -------------------------------------------------------------
Sub ScanDirForLibs
    Dim fileLib As QFileStream
    Dim fileDeUpx As QFileStream
    Dim fileRef AS QFileStream
    DefInt N, iHash, iKnown, iDiff
    DefStr sFileName, sStrFile, sTmp, sShellString, sStrRef, sDiff
    DefSng sngStart
    N = 0
    While N < slLibNames.ItemCount
        ' Check If Lib File is an UPXED file 
        If fileLib.Open(sLibDir & slLibNames.Item(N), fmOpenRead) <> 0 Then
            sStrFile = fileLib.ReadBinStr (fileLib.Size)        ' read file in sStrFile
            fileLib.Close
            If (Mid$(sStrFile, &H1F9, 4) = "UPX0" And Mid$(sStrFile, &H221, 4) = "UPX1") Then    ' UPX Signatures in file
                Kill "DeUpxTmp.Lib"
                sngStart = Timer
                While FileExists ("DeUpxTmp.Lib") <> 0
                    DoEvents
                    sngChrono = Timer - sngStart
                    If sngChrono > 4 Then Exit While
                Wend
                If sngChrono <= 4 Then
                    sShellString = "UPX -d -o DeUpxTmp.Lib " & sLibDir & slLibNames.Item(N)
                    Shell sShellString
                    sngStart = Timer
                    While fileDeUpx.Open ("DeUpxTmp.Lib", fmOpenRead) = 0
                        DoEvents
                        sngChrono = Timer - sngStart
                        If sngChrono > 4 Then Exit While
                    Wend
                    If sngChrono < 4 Then
                        ' Get DE_UPXED Library content in sStrFile
                        sStrFile = fileDeUpx.ReadBinStr (fileDeUpx.Size)  ' read file in sStrFile
                        fileDeUpx.close
                        iHash = Hash32Bit (sStrFile)                  ' compute Hash value for file
                        ' Count the number of diffrences between the Library and the reference ones (The W.Wu ones at BasicGuru)
                        If fileRef.Open (slLibNames.Item(N), fmOpenRead) <> 0 Then
                            sStrRef = fileRef.ReadBinStr(fileRef.Size)
                            iDiff = CountDiffBytes (sStrRef, sStrFile) '("Mon Texte est bon", "Mon Texte est bon")
'                            ShowMessage ("LenStrFile = " & Str$(Len(sStrFile)) & "\n LenStrRef = " & Str$(Len(sStrRef)) & "\n  DiffBytes : " & Hex$(iDiff))
                            fileRef.Close
                        Else
                            iDiff = &HFFFFFFFE      ' -2 = Cant Open Reference Lib File (The Original ones)
                        End If
                        Select Case iDiff
                            Case &HFFFFFFFF
                                sDiff = "FILES <> SIZE"
                            Case &HFFFFFFFE
                                sDiff = "CANT OPEN \"" & slLibNames.Item(N) & "\""
                            Case Else
                                sDiff = Str$(iDiff)
                        End Select
                        iKnown = CheckKnownLib (iHash)                ' check if Lib is from a known group
                        ' Print results
                        If iKnown = -1 Then
                            slKnownLibs.AddItems (Hex$(iHash) & "*" & slLibNames.Item(N) & "*" & sNewGroupName)
                            sTmp = "NEW   LIB: \"" & slLibNames.Item(N) & "\""
                            sTmp = sTmp & Space$ (35 - Len(sTmp))
                            sTmp = sTmp & "Group Name: \"" & sNewGroupName & "\""
                            sTmp = sTmp & Space$ (75 - Len(sTmp))
                            sTmp = sTmp & "DiffCount = " & sDiff
                            Print sTmp
                            slText.AddItems sTmp
                        Else
                            sTmp = "KNOWN LIB: \"" & slLibNames.Item(N) & "\""
                            sTmp = sTmp & Space$ (35 - Len(sTmp))
                            sTmp = sTmp & "Group Name: \"" & sGroupName & "\""
                            sTmp = sTmp & Space$ (75 - Len(sTmp))
                            sTmp = sTmp & "DiffCount = " & sDiff
                            Print sTmp
                            slText.AddItems sTmp
                        End If
                    Else
                        sTmp = " *** CANT OPEN \"DeUpxTmp.Lib\" of \"" & sLibDir & slLibNames.Item(N) & "\""
                        Print sTmp
                        slText.AddItems sTmp
                    End If
                Else
                    sTmp = " *** CANT DELETE \"DeUpxTmp.Lib\""
                    Print sTmp
                    slText.AddItems sTmp
                End If
            Else
                sTmp = " *** NOT AN UPXED FILE \"" & slLibNames.Item(N) & "\""
                sTmp = sTmp & Space$ (35 - Len(sTmp)) & "  in   \"" & sLibDir & "\""
                Print sTmp
                slText.AddItems sTmp
            End If
        Else 
                sTmp = " *** CANT OPEN \"" & slLibNames.Item(N) & "\""
                sTmp = sTmp & Space$ (35 - Len(sTmp)) & "  in   \"" & sLibDir & "\""
                Print sTmp
                slText.AddItems sTmp
        End If
        Inc N
    Wend
End Sub
' -------------------------------------------------------------
'
